<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\User;
use App\FechaVotaciones;
use App\TipoDocumento;
use App\Role;
use App\Carrera;
use App\ConcejoDirectivo;
use App\CandidatoDocente;
use App\CandidatoEstudiante;

class AdministradorController extends Controller
{
    

    public function __construct(){


        $this->middleware("Administrador");

    }
//Vistas
//administrador
    public function index(){

        return view("administrador.administrador");

    }

    //CRUD Concejo directivo
    //vista
    public function concejoDirectivos(){

        $concejoDirectivos = ConcejoDirectivo::all();
        return view("administrador.concejoDirectivos",compact("concejoDirectivos"));

    }

    public function resultadoEstudiante(){
        $concejoId = ConcejoDirectivo::where("nombre","Estudiante")->first();

        $fechaVotaciones = FechaVotaciones::select("id")
        ->where("concejo_directivo_id",$concejoId["id"])
        ->orderByDesc("id")
        ->first();

        $candidatos = CandidatoEstudiante::where("fecha_votacione_id",$fechaVotaciones["id"])
        ->orderByDesc("votos")
        ->get();
        return view("administrador.resultadoEstudiante",compact("candidatos"));

    }

    public function verVotaciones(Request $request){
        
        $fechaVotaciones = FechaVotaciones::where("id",$request->id)->first();
        $concejoEstudiante = ConcejoDirectivo::where("nombre","Estudiante")->first();
        $concejoDocente = ConcejoDirectivo::where("nombre","Docente")->first();

        if ($fechaVotaciones["concejo_directivo_id"] == $concejoEstudiante["id"]) {
            $candidatos = CandidatoEstudiante::where("fecha_votacione_id",$fechaVotaciones["id"])
            ->orderByDesc("votos")
            ->get();
        }else{
            $candidatos = CandidatoDocente::where("fecha_votacione_id",$fechaVotaciones["id"])
            ->orderByDesc("votos")
            ->get();
        }

        
        return view("administrador.verVotaciones",compact("candidatos"));

    }

    public function resultadoDocente(){
        $concejoId = ConcejoDirectivo::where("nombre","Docente")->first();

        $fechaVotaciones = FechaVotaciones::select("id")
        ->where("concejo_directivo_id",$concejoId["id"])
        ->orderByDesc("id")
        ->first();

        $candidatos = CandidatoDocente::where("fecha_votacione_id",$fechaVotaciones["id"])
        ->orderByDesc("votos")
        ->get();
        return view("administrador.resultadoDocente",compact("candidatos"));

    }

    public function registrarConcejo($mensajeError=null){

        return view("administrador.registrarConcejo",compact("mensajeError"));

    }

    public function guardarConcejo(Request $request){

        if (empty($request->nombre)) {
            $mensaje = "Los campos con (*) son obligatorios";
            return $this->registrarConcejo($mensaje);
        }

        ConcejoDirectivo::create([

            "nombre" => $request->nombre
        ]);

        return redirect("/concejoDirectivos");

    }

    public function editarConcejo(Request $request,$mensajeError=null){

        $concejoDirectivos = ConcejoDirectivo::where("id",$request->id)->first();
        return view("administrador.editarConcejo",compact("concejoDirectivos","mensajeError"));
        

    }

    public function actualizarConcejo(Request $request){

        
        if (empty($request->nombre)) {
            $mensaje = "Los campos con (*) son obligatorios";
            return $this->editarConcejo($request,$mensaje);
        }

        ConcejoDirectivo::where("id",$request->id)->update([

            "nombre" => $request->nombre

        ]);
        
        return redirect("/concejoDirectivos");

    }

    //CRUD carreras
    //vista
    public function carreras(){

        $carreras = Carrera::all();
        return view("administrador.carreras",compact("carreras"));

    }

    public function registrarCarreras($mensajeError=null){

        return view("administrador.registrarCarreras",compact("mensajeError"));

    }

    public function guardarCarreras(Request $request){

        if (empty($request->nombre)) {
            $mensaje = "Los campos con (*) son obligatorios";
            return $this->registrarCarreras($mensaje);
        }

        Carrera::create([

            "nombre" => $request->nombre
        ]);

        return redirect("/carreras");

    }

    public function editarCarreras(Request $request,$mensajeError=null){

        $carreras = Carrera::where("id",$request->id)->first();
        return view("administrador.editarCarreras",compact("carreras","mensajeError"));
        

    }

    public function actualizarCarreras(Request $request){

        
        if (empty($request->nombre)) {
            $mensaje = "Los campos con (*) son obligatorios";
            return $this->editarCarreras($request,$mensaje);
        }

        Carrera::where("id",$request->id)->update([

            "nombre" => $request->nombre

        ]);
        
        return redirect("/carreras");

    }

    //CRUD roles
    //vista
    public function roles(){

        $roles = Role::all();
        return view("administrador.roles",compact("roles"));

    }

    public function editarRoles(Request $request,$mensajeError=null){

        $roles = Role::where("id",$request->id)->first();
        return view("administrador.editarRoles",compact("roles","mensajeError"));
        

    }

    public function actualizarRoles(Request $request){

        
        if (empty($request->nombre)) {
            $mensaje = "Los campos con (*) son obligatorios";
            return $this->editarRoles($request,$mensaje);
        }

        Role::where("id",$request->id)->update([

            "nombre_rol" => $request->nombre

        ]);
        
        return redirect("/roles");

    }

    public function registrarRoles($mensajeError=null){

        return view("administrador.registrarRoles",compact("mensajeError"));

    }

    public function guardarRoles(Request $request){

        if (empty($request->nombre)) {
            $mensaje = "Los campos con (*) son obligatorios";
            return $this->registrarRoles($mensaje);
        }

        Role::create([

            "nombre_rol" => $request->nombre
        ]);

        return redirect("/roles");

    }

    //CRUD tipo de documentos
    //Vista
    public function tipoDocumentos(){

        $tipoDocumentos = TipoDocumento::all();
        return view("administrador.tipoDocumentos",compact("tipoDocumentos"));

    }

    public function guardarDocumentos(Request $request){

        if (empty($request->nombre)) {
            $mensaje = "Los campos con (*) son obligatorios";
            return $this->registrarDocumentos($mensaje);
        }

        TipoDocumento::create([

            "nombre" => $request->nombre
        ]);

        return redirect("/tipoDocumentos");

    }

    public function registrarDocumentos($mensajeError=null){

        return view("administrador.registrarDocumentos",compact("mensajeError"));

    }

    public function editarDocumentos(Request $request,$mensajeError=null){

        $tipoDocumentos = TipoDocumento::where("id",$request->id)->first();
        return view("administrador.editarDocumentos",compact("tipoDocumentos","mensajeError"));
        

    }

    public function actualizarDocumentos(Request $request){

        
        if (empty($request->nombre)) {
            $mensaje = "Los campos con (*) son obligatorios";
            return $this->editarDocumentos($request,$mensaje);
        }

        TipoDocumento::where("id",$request->id)->update([

            "nombre" => $request->nombre

        ]);
        
        return redirect("/tipoDocumentos");

    }

    //CRUD de usuarios
    //Registra usuarios
    public function registrar(){

        return view("administrador.registroUsuario");

    }
    //Mostrar todos los usuarios
    public function usuarios(){

        $usuarios = User::all();
        return view("administrador.usuarios",compact("usuarios"));

    }
    //Eliminar usuarios
    public function eliminarUsuario(Request $request){

        User::where("id",$request->id)->delete();
        return redirect("/usuarios");

    }
    //Mostrar usuario a actualizar
    public function mostrarUsuario(Request $request){

        $usuario = User::where("id",$request->id)->first();

        return view("administrador.mostrarUsuario",compact("usuario"));

    }
    //Actualizar usuario
    public function actualizarUsuario(Request $request){

            $this->validate($request,[
                'name' => ['required', 'string', 'max:255'],
                'primerApellido' => ['required', 'string', 'max:255'],
            'segundoApellido' => ['required', 'string', 'max:255'],
            'tipoDocumento_id' => ['required', 'integer'],
            'numeroDocumento' => ['required', 'string', 'max:255'],
            'fechaExpedicion' => ['required', 'date'],
            'telefono' => ['required', 'string', 'max:255'],
            'celular' => ['required', 'string', 'max:255'],
            'direccion' => ['required', 'string', 'max:255'],
            'ciudad_id' => ['required', 'integer'],
            'role_id' => ['required', 'integer'],
            'codigoVotacion' => ['required', 'integer'],
            'email' => ['required', 'string', 'email', 'max:255'],

            ]); 
        
        if ($archivo = $request->file('foto')) {
            
            $nombreFoto = $archivo->getClientOriginalName();
            $archivo->move("fotoUsuarios", $nombreFoto);

        }else{
            $foto = User::where("id",$request->id)->first();
            $nombreFoto=$foto["foto"];
        }    


        User::where("id",$request->id)->update([
            'name' => $request->name,
            'primerApellido' => $request->primerApellido,
            'segundoApellido' => $request->segundoApellido,
            'carrera_id' => $request->carrera_id,
            'semestre' => $request->semestre,
            'tipoDocumento_id' => $request->tipoDocumento_id,
            'numeroDocumento' => $request->numeroDocumento,
            'fechaExpedicion' => $request->fechaExpedicion,
            'telefono' => $request->telefono,
            'celular' => $request->celular,
            'direccion' => $request->direccion,
            'ciudad_id' => $request->ciudad_id,
            'codigoVotacion' => $request->codigoVotacion,
            'email' => $request->email,
            'role_id' => $request->role_id,
            'foto' => $nombreFoto,
        ]);

        return redirect("/usuarios");

    }

    //CRUD fecha de votaciones
    //Mostrar formulario
    public function fechaVotacion(){

        return view("administrador.fechaVotacion");

    }

    public function listaFechas(){
        
        $fechas = FechaVotaciones::all();
        return view("administrador.listaFechas",compact("fechas"));

    }
    public function editarFechaVotacion(Request $request,$mensajeError=null){

        $fechaVotaciones = FechaVotaciones::where("id",$request->id)->first();
        return view("administrador.editarFechaVotaciones",compact("fechaVotaciones","mensajeError"));
        

    }
    //Actualizar fecha de votaciones
    public function actualizarFechaVotacion(Request $request){

        $fechaI= explode("/",$request->fechaInicio);
        $horaI = explode("/",$request->horaInicio);
        $fechaInicio = $fechaI[0]." ".$horaI[0];

        $fechaF= explode("/",$request->fechaFinal);
        $horaF = explode("/",$request->horaFinal);
        $fechaFinal = $fechaF[0]." ".$horaF[0];
        
        
        $fechaVotacion = FechaVotaciones::where("id","!=",$request->id)->get();
        foreach ($fechaVotacion as $fecha) {

            if ($fechaInicio.":00"  <= $fecha["fechaFinal"]
                && $fechaInicio.":00" >= $fecha["fechaInicio"]
                && $fecha["concejo_directivo_id"] == $request->concejo_directivo_id) {
                    
                    $errorFecha = "Esta fecha ya esta asignada para este concejo directivo";
                    return view("administrador.fechaVotacion", compact("errorFecha"));
            }else if ($fechaFinal.":00"  >= $fecha["fechaInicio"]
                    && $fechaFinal.":00" <= $fecha["fechaFinal"]
                    && $fecha["concejo_directivo_id"] == $request->concejo_directivo_id) {
                        
                        $errorFecha = "Esta fecha ya esta asignada para este concejo directivo";
                        return view("administrador.fechaVotacion", compact("errorFecha"));
                }

        }   

        
        if (
            empty($request->fechaInicio) ||
            empty($request->horaInicio)  ||
            empty($request->fechaFinal)  ||
            empty($request->horaFinal)) {
                
            $mensaje = "los campos con (*) son obligatorios";
            return $this->editarFechaVotacion($request,$mensaje);
        }

        date_default_timezone_set('America/Bogota');
        $fechaActual = date("Y-m-d h:i:s");
        FechaVotaciones::where("id",$request->id)->update([

            "fechaActual" => $fechaActual,
            "fechaInicio" => $fechaInicio,
            "fechaFinal" => $fechaFinal,
            
        ]);
        
        $mensaje="Registro guardado con exito";
        return view("administrador.administrador",compact("mensaje"));

    }
    //Guardar Fecha de votaciones
    public function guardarFechaVotacion(Request $request){

        $fechaI= explode("/",$request->fechaInicio);
        $horaI = explode("/",$request->horaInicio);
        $fechaInicio = $fechaI[0]." ".$horaI[0];

        $fechaF= explode("/",$request->fechaFinal);
        $horaF = explode("/",$request->horaFinal);
        $fechaFinal = $fechaF[0]." ".$horaF[0];
        
        
        $fechaVotacion = FechaVotaciones::all();
        foreach ($fechaVotacion as $fecha) {

            if ($fechaInicio.":00"  >= $fecha["fechaInicio"] 
                && $fechaFinal.":00" <= $fecha["fechaFinal"] 
                && $fecha["concejo_directivo_id"] == $request->concejo_directivo_id) {

                    $errorFecha = "Esta fecha ya esta asignada para este concejo directivo";
                    return view("administrador.fechaVotacion", compact("errorFecha"));

            }else if($fecha["fechaInicio"] >= $fechaInicio.":00"
                    && $fecha["fechaFinal"] <= $fechaFinal.":00"
                    && $fecha["concejo_directivo_id"] == $request->concejo_directivo_id ){
                       
                        $errorFecha = "Ya existe una fecha asignada en este rango de fechas";
                        return view("administrador.fechaVotacion", compact("errorFecha"));

            }else if($fecha["fechaInicio"] >= $fechaInicio.":00"
                    && $fechaFinal.":00" <= $fecha["fechaFinal"]
                    && $fecha["concejo_directivo_id"] == $request->concejo_directivo_id){

                        $errorFecha = "Ya existe una fecha asignada en este rango de fechas";
                        return view("administrador.fechaVotacion", compact("errorFecha"));  

            }else if($fechaInicio.":00"  >= $fecha["fechaInicio"]
                    && $fechaInicio.":00"  <= $fecha["fechaFinal"]
                    && $fecha["fechaFinal"] <=  $fechaFinal.":00" 
                    && $fecha["concejo_directivo_id"] == $request->concejo_directivo_id){

                        $errorFecha = "Ya existe una fecha asignada en este rango de fechas";
                        return view("administrador.fechaVotacion", compact("errorFecha"));

            }
        }

        $this->validate($request,[

            "fechaInicio" => ['required', 'date'],
            "horaInicio" => ['required'],
            "fechaFinal" => ['required', 'date'],
            "horaFinal" => ['required'],

        ]);

        date_default_timezone_set('America/Bogota');
        $fechaActual = date("Y-m-d h:i:s");
        FechaVotaciones::create([

            "fechaActual" => $fechaActual,
            "fechaInicio" => $fechaInicio,
            "fechaFinal" => $fechaFinal,
            "concejo_directivo_id" => $request->concejo_directivo_id
        ]);
        
        $mensaje="Registro guardado con exito";
        return view("administrador.administrador",compact("mensaje"));

    }


}
