<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddNewColumnsToUsers extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('users', function (Blueprint $table) {
            $table->string('primerApellido',45);
            $table->string('segundoApellido',45);
            $table->foreignId('carrera_id')->nullable()->constrained("carreras");
            $table->integer('semestre')->nullable();
            $table->foreignId('tipoDocumento_id')->constrained("tipo_documentos");
            $table->string('numeroDocumento');
            $table->date('fechaExpedicion');
            $table->string('telefono',45);
            $table->string('celular',45);
            $table->string('direccion',100);
            $table->foreignId('ciudad_id')->constrained("ciudades");
            $table->foreignId('role_id')->constrained("roles");
            $table->string('codigoVotacion');
            $table->string('foto')->nullable();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('users', function (Blueprint $table) {
            $table->dropColumn('primerApellido');
            $table->dropColumn('segundoApellido');
            $table->dropColumn('carrera_id');
            $table->dropColumn('semestre');
            $table->dropColumn('tipoDocumento_id');
            $table->dropColumn('numeroDocumento');
            $table->dropColumn('fechaExpedicion');
            $table->dropColumn('telefono');
            $table->dropColumn('celular');
            $table->dropColumn('direccion');
            $table->dropColumn('ciudad_id');
            $table->dropColumn('codigoVotacion');
        });
    }
}
