<?php

use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {

    return redirect(route('login'));
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');


//Rutas de rol Docentes
Route::get('/docente','DocenteController@index');
Route::get('/candidatos','DocenteController@candidatosDocente');
Route::get('/postularse','DocenteController@postularse');
Route::get('/resultadoDocente','DocenteController@resultadoDocente');
Route::post('/validarCodigo','DocenteController@validarCodigo');
Route::post('/crearPostulacion','DocenteController@crearPostulacion');
Route::post('/votarDocente','DocenteController@votarDocente');

//Rutas de rol Estudiante
Route::get('/estudiante','EstudianteController@index');
Route::get('/candidatosEstudiante','EstudianteController@candidatosEstudiante');
Route::get('/postularseEstudiante','EstudianteController@postularse');
Route::get('/resultadoEstudiante','EstudianteController@resultadoEstudiante');
Route::post('/validarCodigoEstudiante','EstudianteController@validarCodigoEstudiante');
Route::post('/crearPostulacionEstudiante','EstudianteController@crearPostulacion');
Route::post('/votarEstudiante','EstudianteController@votarEstudiante');


//rutas de rol Administrador
//interfaces
Route::get('/fechaVotacion','AdministradorController@fechaVotacion');
Route::get('/listaFechas','AdministradorController@listaFechas');
Route::get('/administrador','AdministradorController@index');
Route::get('/registrar','AdministradorController@registrar');
Route::get('/usuarios','AdministradorController@usuarios');
Route::get('/carreras','AdministradorController@carreras');
Route::get('/concejoDirectivos','AdministradorController@concejoDirectivos');
Route::get('/registrarConcejo','AdministradorController@registrarConcejo');
Route::get('/registrarCarreras','AdministradorController@registrarCarreras');
Route::get('/roles','AdministradorController@roles');
Route::get('/registrarRoles','AdministradorController@registrarRoles');
Route::get('/tipoDocumentos','AdministradorController@tipoDocumentos');
Route::get('/registrarDocumentos','AdministradorController@registrarDocumentos');
Route::get('/resultadoDocenteAdministrador','AdministradorController@resultadoDocente');
Route::get('/resultadoEstudianteAdministrador','AdministradorController@resultadoEstudiante');
Route::get('/resultadoEstudianteAdministrador','AdministradorController@resultadoEstudiante');

//CRUD carreras

Route::post('/editarCarreras','AdministradorController@editarCarreras');
Route::post('/actualizarCarreras','AdministradorController@actualizarCarreras');
Route::post('/guardarCarreras','AdministradorController@guardarCarreras');
//CRUD concejo directivo
Route::post('/editarConcejo','AdministradorController@editarConcejo');
Route::post('/actualizarConcejo','AdministradorController@actualizarConcejo');
Route::post('/guardarConcejo','AdministradorController@guardarConcejo');
//CRUD roles
Route::post('/editarRoles','AdministradorController@editarRoles');
Route::post('/actualizarRoles','AdministradorController@actualizarRoles');
Route::post('/guardarRoles','AdministradorController@guardarRoles');
//CRUD Tipos de documentos
Route::post('/guardarDocumentos','AdministradorController@guardarDocumentos');
Route::post('/editarDocumentos','AdministradorController@editarDocumentos');
Route::post('/actualizarDocumentos','AdministradorController@actualizarDocumentos');
//CRUD usuario
Route::post('/eliminarUsuario','AdministradorController@eliminarUsuario');
Route::post('/mostrarUsuario','AdministradorController@mostrarUsuario');
Route::post('/actualizarUsuario','AdministradorController@actualizarUsuario');
//Fecha votaciones
Route::post('/editarFechaVotacion','AdministradorController@editarFechaVotacion');
Route::post('/actualizarFechaVotacion','AdministradorController@actualizarFechaVotacion');
Route::post('/guardarFechaVotacion','AdministradorController@guardarFechaVotacion');
Route::post('/verVotaciones','AdministradorController@verVotaciones');

Route::resource("usuario","UsuarioController");

